/*
 ķ
   Program..: KEYPAD.PRG                            
   Author...: Nick Alexander                        
   Date.....: Dec 20, 2000                          
   Modified by Bruce Neuman                         
   Images by Blake Neuman                           
   Date.....: june 10, 2011                         
   Date.....: june 10, 2011                         
 Ľ
*/

#include 'inkey.ch'
#include 'dccolor.ch'
#include 'appevent.ch'
#include 'gra.ch'
#include 'xbp.ch'
#include 'dcmsg.ch'
#include 'dcdialog.ch'

MEMVAR lCapsLock, cCapsLock

FUNCTION PopKeyPad( cValue, cText )


LOCAL GetList := {}, GetOptions, cSaveValue, oCancelButton, ;
         nWidth := AppDeskTop():currentSize()[1]
local aRegion := { ;
             {37,0,114,1},;
             {36,1,115,2},;
             {35,2,116,3},;
             {34,3,117,4},;
             {33,4,118,5},;
             {32,5,119,7},;
             {31,7,119,48},;
             {7,48,119,49},;
             {5,49,119,50},;
             {4,50,119,51},;
             {3,51,119,52},;
             {2,52,119,53},;
             {1,53,119,54},;
             {0,54,119,95},;
             {1,95,118,96},;
             {2,96,117,97},;
             {3,97,116,98},;
             {4,98,115,99},;
             {5,99,114,100} }


   PRIVATE lFirstTime := .t., lCapsLock, cCapsLock

        DEFAULT cValue := space(30)
        DEFAULT lCapsLock := .F.
        DEFAULT cCapsLock := '         '
        DEFAULT cText := 'Enter Data'
        cSaveValue := cValue

   @   0,   5 DCSAY  cText  FONT '20.Arial Bold' SAYCENTER saycolor 10  SIZE 600,40 PIXEL

   @   50,  0 DCGET cValue FONT '20.Arial Bold' SIZE 680,40 PIXEL EDITPROTECT {||.t.} ;
             ID 'ACCUM'      // Courier New


   @ 200,561 DCPUSHBUTTON CAPTION 4050 FONT '12.Arial Bold' SIZE 110,100 PIXEL ;     //200,590
      ACCELKEY 13 ;      // [enter]
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)};
      STATIC REGION aRegion;

    @ 100,  0 DCPUSHBUTTON CAPTION {||IIF( lCapsLock,4001,4201) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('1','!',@cValue,GetList)} ;
      ACCELKEY Asc('1') ;
      EVAL _DualFlashBlock(4001,4101,4201,4301)

   @ 100, 50 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4002,4202) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('2','@',@cValue,GetList)} ;
      ACCELKEY Asc('2') ;
      EVAL _DualFlashBlock(4002,4102,4202,4302)

   @ 100,100 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4003,4203) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('3','#',@cValue,GetList)} ;
      ACCELKEY Asc('3') ;
      EVAL _DualFlashBlock(4003,4103,4203,4303)

   @ 100,150 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4004,4204) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('4','$',@cValue,GetList)} ;
      ACCELKEY Asc('4') ;
      EVAL _DualFlashBlock(4004,4104,4204,4304)

   @ 100,200 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4005,4205) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('5','%',@cValue,GetList)} ;
      ACCELKEY Asc('5') ;
      EVAL _DualFlashBlock(4005,4105,4205,4305)

   @ 100,250 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4006,4206) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('6','^',@cValue,GetList)} ;
      ACCELKEY Asc('6') ;
      EVAL _DualFlashBlock(4006,4106,4206,4306)

   @ 100,300 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4007,4207) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('7','&',@cValue,GetList)} ;
      ACCELKEY Asc('7') ;
      EVAL _DualFlashBlock(4007,4107,4207,4307)

   @ 100,350 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4008,4208) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('8','*',@cValue,GetList)} ;
      ACCELKEY Asc('8') ;
      EVAL _DualFlashBlock(4008,4108,4208,4308)

   @ 100,400 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4009,4209) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('9','(',@cValue,GetList)} ;
      ACCELKEY Asc('9') ;
      EVAL _DualFlashBlock(4009,4109,4209,4309)

   @ 100,450 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4010,4210) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('0',')',@cValue,GetList)} ;
      ACCELKEY Asc('0') ;
      EVAL _DualFlashBlock(4010,4110,4210,4310)

   @ 100,500 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4011,4211) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('-','_',@cValue,GetList)} ;
      ACCELKEY {Asc('-'),Asc('_')} ;
      EVAL _DualFlashBlock(4011,4111,4211,4311)

   @ 100,550 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4012,4212) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('=','+',@cValue,GetList)} ;
      ACCELKEY {Asc('='),Asc('+')} ;
      EVAL _DualFlashBlock(4012,4112,4212,4312)

   @ 100,600 DCPUSHBUTTON CAPTION 4213 FONT '16.Arial Bold' SIZE 70,50 PIXEL ;
      ACTION {||cValue := Substr(cValue,1,Len(cValue)-1),Accum('','',@cValue,GetList)} ;
      ACCELKEY 8 ;  //backspace
      EVAL _FlashBlock(4213,4313)

   @ 150, 20 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4014,4214) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('q','Q',@cValue,GetList)} ;
      ACCELKEY {Asc('q'),Asc('Q')} ;
      EVAL _DualFlashBlock(4014,4114,4214,4314)

   @ 150, 70 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4015,4215) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('w','W',@cValue,GetList)} ;
      ACCELKEY {Asc('w'),Asc('W')} ;
      EVAL _DualFlashBlock(4015,4115,4215,4315)

   @ 150,120 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4016,4216) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('e','E',@cValue,GetList)} ;
      ACCELKEY {Asc('e'),Asc('E')} ;
      EVAL _DualFlashBlock(4016,4116,4216,4316)

   @ 150,170 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4017,4217) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('r','R',@cValue,GetList)} ;
      ACCELKEY {Asc('r'),Asc('R')} ;
      EVAL _DualFlashBlock(4017,4117,4217,4317)

   @ 150,220 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4018,4218) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('t','T',@cValue,GetList)} ;
      ACCELKEY {Asc('t'),Asc('T')} ;
      EVAL _DualFlashBlock(4018,4118,4218,4318)

   @ 150,270 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4019,4219) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('y','Y',@cValue,GetList)} ;
      ACCELKEY {Asc('y'),Asc('Y')} ;
      EVAL _DualFlashBlock(4019,4119,4219,4319)

   @ 150,320 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4020,4220) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('u','U',@cValue,GetList)} ;
      ACCELKEY {Asc('u'),Asc('U')} ;
      EVAL _DualFlashBlock(4020,4120,4220,4320)

   @ 150,370 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4021,4221) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('i','I',@cValue,GetList)} ;
      ACCELKEY {Asc('i'),Asc('I')} ;
      EVAL _DualFlashBlock(4021,4121,4221,4321)

   @ 150,420 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4022,4222) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('o','O',@cValue,GetList)} ;
      ACCELKEY {Asc('o'),Asc('O')} ;
      EVAL _DualFlashBlock(4022,4122,4222,4322)

   @ 150,470 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4023,4223) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('p','P',@cValue,GetList)} ;
      ACCELKEY {Asc('p'),Asc('P')} ;
      EVAL _DualFlashBlock(4023,4123,4223,4323)

   @ 150,520 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4024,4224) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('[','{',@cValue,GetList)} ;
      ACCELKEY {Asc('['),Asc('{')} ;
      EVAL _DualFlashBlock(4024,4124,4224,4324)

   @ 150,570 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4025,4225) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum(']','}',@cValue,GetList)} ;
      ACCELKEY {Asc(']'),Asc('}')} ;
      EVAL _DualFlashBlock(4025,4125,4225,4325)

   @ 150,620 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4026,4226) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('\','|',@cValue,GetList)} ;
      ACCELKEY {Asc('\'),Asc('|')} ;
      EVAL _DualFlashBlock(4026,4126,4226,4326)

   @ 200, 40 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4027,4227) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('a','A',@cValue,GetList)} ;
      ACCELKEY {Asc('a'),Asc('A')} ;
      EVAL _DualFlashBlock(4027,4127,4227,4327)

   @ 200, 90 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4028,4228) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('s','S',@cValue,GetList)} ;
      ACCELKEY {Asc('s'),Asc('S')} ;
      EVAL _DualFlashBlock(4028,4128,4228,4328)

   @ 200,140 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4029,4229) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('d','D',@cValue,GetList)} ;
      ACCELKEY {Asc('d'),Asc('D')} ;
      EVAL _DualFlashBlock(4029,4129,4229,4329)

   @ 200,190 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4030,4230) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('f','F',@cValue,GetList)} ;
      ACCELKEY {Asc('f'),Asc('F')} ;
      EVAL _DualFlashBlock(4030,4130,4230,4330)

   @ 200,240 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4031,4231) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('g','G',@cValue,GetList)} ;
      ACCELKEY {Asc('g'),Asc('G')} ;
      EVAL _DualFlashBlock(4031,4131,4231,4331)

   @ 200,290 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4032,4232) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('h','H',@cValue,GetList)} ;
      ACCELKEY {Asc('h'),Asc('H')} ;
      EVAL _DualFlashBlock(4032,4132,4232,4332)

   @ 200,340 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4033,4233) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('j','J',@cValue,GetList)} ;
      ACCELKEY {Asc('j'),Asc('J')} ;
      EVAL _DualFlashBlock(4033,4133,4233,4333)

   @ 200,390 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4034,4234) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('k','K',@cValue,GetList)} ;
      ACCELKEY {Asc('k'),Asc('K')} ;
      EVAL _DualFlashBlock(4034,4134,4234,4334)

   @ 200,440 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4035,4235) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('l','L',@cValue,GetList)} ;
      ACCELKEY {Asc('l'),Asc('L')} ;
      EVAL _DualFlashBlock(4035,4135,4235,4335)

   @ 200,490 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4036,4236) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum(';',':',@cValue,GetList)} ;
      ACCELKEY {Asc(';'),Asc(':')} ;
      EVAL _DualFlashBlock(4036,4136,4236,4336)

   @ 200,540 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4037,4237) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum("'",'"',@cValue,GetList)} ;
      ACCELKEY {Asc("'"),Asc('"')} ;
      EVAL _DualFlashBlock(4037,4137,4237,4337)

   @ 250, 60 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4038,4238) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('z','Z',@cValue,GetList)} ;
      ACCELKEY {Asc('z'),Asc('Z')} ;
      EVAL _DualFlashBlock(4038,4138,4238,4338)

   @ 250,110 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4039,4239) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('x','X',@cValue,GetList)} ;
      ACCELKEY {Asc('x'),Asc('X')} ;
      EVAL _DualFlashBlock(4039,4139,4239,4339)

   @ 250,160 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4040,4240) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('c','C',@cValue,GetList)} ;
      ACCELKEY {Asc('c'),Asc('C')} ;
      EVAL _DualFlashBlock(4040,4140,4240,4340)

   @ 250,210 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4041,4241) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('v','V',@cValue,GetList)} ;
      ACCELKEY {Asc('v'),Asc('V')} ;
      EVAL _DualFlashBlock(4041,4141,4241,4341)

   @ 250,260 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4042,4242) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('b','B',@cValue,GetList)} ;
      ACCELKEY {Asc('b'),Asc('B')} ;
      EVAL _DualFlashBlock(4042,4142,4242,4342)

   @ 250,310 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4043,4243) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('n','N',@cValue,GetList)} ;
      ACCELKEY {Asc('n'),Asc('N')} ;
      EVAL _DualFlashBlock(4043,4143,4243,4343)

   @ 250,360 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4044,4244) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('m','M',@cValue,GetList)} ;
      ACCELKEY {Asc('m'),Asc('M')} ;
      EVAL _DualFlashBlock(4044,4144,4244,4344)

   @ 250,410 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4045,4245) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum(',','<',@cValue,GetList)} ;
      ACCELKEY {Asc(','),Asc('<')} ;
      EVAL _DualFlashBlock(4045,4145,4245,4345)

   @ 250,460 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4046,4246) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('.','>',@cValue,GetList)} ;
      ACCELKEY {Asc('.'),Asc('>')} ;
      EVAL _DualFlashBlock(4046,4146,4246,4346)

   @ 250,510 DCPUSHBUTTON CAPTION {||iif( lCapsLock,4047,4247) } FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
      ACTION {||Accum('/','?',@cValue,GetList)} ;
      ACCELKEY {Asc('/'),Asc('?')} ;
      EVAL _DualFlashBlock(4047,4147,4247,4347)

  @ 300, 0 DCPUSHBUTTON CAPTION 4248 FONT '16.Arial Bold' SIZE 100,50 PIXEL ;
      ACTION {|a,b,o|lCapsLock:=!lCapsLock,DC_GetRefresh(GetList)}

   @ 300,100 DCPUSHBUTTON CAPTION 4049 FONT '16.Arial Bold' SIZE 400,50 PIXEL ;
      ACTION {||Accum(' ',' ',@cValue,GetList)} ;   //space bar
      ACCELKEY 32

  @ 300,500 DCPUSHBUTTON CAPTION 4248 FONT '16.Arial Bold' SIZE 100,50 PIXEL ;
    ACTION {|a,b,o|lCapsLock:=!lCapsLock,DC_GetRefresh(GetList)} //caps lock

  @ 300,600 DCPUSHBUTTON CAPTION 4051 FONT '12.Arial Bold' SIZE 70,50 PIXEL ;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)} ;
      ACCELKEY 27 ;         // esc
      OBJECT oCancelButton
 /*
   @  50,  0 DCPUSHBUTTON CAPTION 4052 FONT '12.Arial Bold' SIZE 80,50 PIXEL ;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)} ;
      ACCELKEY 27 ;
      OBJECT oCancelButton
 */
   IF nWidth > 900
      n= -15
      //100
      @ 100,  n+700 DCPUSHBUTTON CAPTION 2107 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
         ACTION {||Accum('7','7',@cValue,GetList)} ;
         ACCELKEY Asc('7') ;
         EVAL _FlashBlock(2107,2207)

      @ 100, n+60+700 DCPUSHBUTTON CAPTION 2108 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
         ACTION {||Accum('8','8',@cValue,GetList)} ;
         ACCELKEY Asc('8') ;
         EVAL _FlashBlock(2108,2208)

      @ 100,n+120+700 DCPUSHBUTTON CAPTION 2109 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
         ACTION {||Accum('9','9',@cValue,GetList)} ;
         ACCELKEY Asc('9') ;
         EVAL _FlashBlock(2109,2209)
        //166
      @ 166,  n+0+700 DCPUSHBUTTON CAPTION 2104 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
         ACTION {||Accum('4','4',@cValue,GetList)} ;
         ACCELKEY Asc('4') ;
         EVAL _FlashBlock(2104,2204)

      @ 166, n+60+700 DCPUSHBUTTON CAPTION 2105 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
         ACTION {||Accum('5','5',@cValue,GetList)} ;
         ACCELKEY Asc('5') ;
         EVAL _FlashBlock(2105,2205)

      @ 166,n+120+700 DCPUSHBUTTON CAPTION 2106 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
         ACTION {||Accum('6','6',@cValue,GetList)} ;
         ACCELKEY Asc('6') ;
         EVAL _FlashBlock(2106,2206)

      @ 233,  n+0+700 DCPUSHBUTTON CAPTION 2101 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
         ACTION {||Accum('1','1',@cValue,GetList)} ;
         ACCELKEY Asc('1') ;
         EVAL _FlashBlock(2101,2201)

      @ 233, n+60+700 DCPUSHBUTTON CAPTION 2102 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
         ACTION {||Accum('2','2',@cValue,GetList)} ;
         ACCELKEY Asc('2') ;
         EVAL _FlashBlock(2102,2202)

      @ 233,n+120+700 DCPUSHBUTTON CAPTION 2103 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
         ACTION {||Accum('3','3',@cValue,GetList)} ;
         ACCELKEY Asc('3') ;
         EVAL _FlashBlock(2103,2203)

      @ 300,  n+0+700 DCPUSHBUTTON CAPTION 2100 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
         ACTION {||Accum('0','0',@cValue,GetList)} ;
         ACCELKEY Asc('0') ;
         EVAL _FlashBlock(2100,2200)

      @ 300, n+60+700 DCPUSHBUTTON CAPTION 2110 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
         ACTION {||Accum('.','.',@cValue,GetList)} ;
         ACCELKEY 46 ;
         EVAL _FlashBlock(2110,2210)

      @ 300,n+120+700 DCPUSHBUTTON CAPTION 2112 FONT '16.Arial Bold' SIZE 50,50 PIXEL ;
         ACTION {||Accum('-','-',@cValue,GetList)} ;
         ACCELKEY 45 ;
         EVAL _FlashBlock(2112,2212)

   ENDIF


        DCGETOPTIONS ;
                 COLOR XBPSYSCLR_TRANSPARENT;  //COLOR GRA_CLR_DARKBLUE ;
                 bitmap 2301 ;
                 NOMINBUTTON ;
                 NOMAXBUTTON

        DCREAD GUI ;
           FIT ;
                 MODAL ;
           TITLE 'Virtual Keyboard' ;
           SETFOCUS @oCancelButton ;
           TO lStatus ;
           OPTIONS GetOptions ;

        IF !lStatus
          cValue := cSaveValue
        ENDIF

RETURN cValue

STATIC FUNCTION Accum ( cKey, cCapsKey, cValue, GetList )

        IF lFirstTime
          cValue := ''
        ENDIF

        lFirstTime := .f.

        cValue += iif(lCapsLock,cCapsKey,cKey)

 DC_GetRefresh(GetList,'ACCUM')
 SetAppFocus(DC_GetObject(GetList,'ACCUM'))   // <<<<<<<<<<< add this

RETURN nil

* ----------------

STATIC FUNCTION _FlashBlock( n1, n2 )

RETURN {|o|o:lbdown := {|a,b,x|_FlashBlock2(x,n1,n2)}}

* ----------------

STATIC FUNCTION _FlashBlock2( oXbp, n1, n2 )

_Flash( oXbp, n1, n2 )

RETURN nil

* ----------------

STATIC FUNCTION _DualFlashBlock( n1, n2, n3, n4 )

RETURN {|o|o:lbdown := {|a,b,x|_DualFlashBlock2(x,n1,n2,n3,n4)}}

* ----------------

STATIC FUNCTION _DualFlashBlock2( oXbp, n1, n2, n3, n4 )

_DualFlash( oXbp, n1, n2, n3, n4 )

RETURN nil

* -----------

STATIC FUNCTION _Flash( oButton, cCaption1, cCaption2 )
oButton:setFontCompoundName('12.Arial Bold')
oButton:setCaption(DC_GetBitmap(cCaption2))
Sleep(10)
oButton:setFontCompoundName('16.Arial Bold')
oButton:setCaption(DC_GetBitmap(cCaption1))


RETURN nil

* -----------

STATIC FUNCTION _DualFlash( oButton, cCaption1, cCaption2, cCaption3, cCaption4)

if lCapsLock
   oButton:setFontCompoundName('12.Arial Bold')
   oButton:setCaption(DC_GetBitmap(cCaption2))
   Sleep(10)
   oButton:setFontCompoundName('16.Arial Bold')
   oButton:setCaption(DC_GetBitmap(cCaption1))

else
   oButton:setFontCompoundName('12.Arial Bold')
   oButton:setCaption(DC_GetBitmap(cCaption4))
   Sleep(10)
   oButton:setFontCompoundName('16.Arial Bold')
   oButton:setCaption(DC_GetBitmap(cCaption3))

endif

RETURN nil